<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>updateUser</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">

    <div class="container jumbotron">
        <div class="text-center mb-4">
            <h3>Chi tiết User</h3>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">
                <label for="input-firstname">First Name</label>
            </div>
            <div class="col-sm-8">
                <input class="form-control" placeholder="Nhập Firstname ..." id="input-firstname" type="text" />
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">
                <label for="input-lastname">Last Name</label>
            </div>
            <div class="col-sm-8">
                <input class="form-control" placeholder="Nhập Last Name ..." id="input-lastname" type="text">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">
                <label for="input-subject">Subject</label>
            </div>
            <div class="col-sm-8">
                <input class="form-control" placeholder="Nhập Subject ..." id="input-subject" type="text">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">
                <label for="select-country">Country</label>
            </div>
            <div class="col-sm-8">
                <select class="form-control" id="select-country" name="Customertype">
                    <option value="VN">Việt Nam</option>
                    <option value="USA">USA</option>
                    <option value="AUS">Australia</option>
                    <option value="CAN">Canada</option>
                </select>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">
                <label for="select-customertype">Customer type</label>
            </div>
            <div class="col-sm-8">
                <select class="form-control" id="select-customertype" name="Customertype">
                    <option value="Standard">Standard</option>
                    <option value="Gold">Gold</option>
                    <option value="Premium">Premium</option>
                </select>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">
                <label for="select-register-status">Register Status</label>
            </div>
            <div class="col-sm-8">
                <select class="form-control" id="select-register-status" name="registerStatus">
                    <option value="New">New</option>
                    <option value="Accepted">Accepted</option>
                    <option value="Denied">Denied</option>
                </select>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">
            </div>
            <div class="col-sm-8">
                <button type="button" class="btn btn-success w-25" id="btn-update-user" onclick="updateUser()">
                    Update user
                </button>
                <button type="button" class="btn btn-success w-25">Hủy bỏ</button>
            </div>
        </div>
    </div>

</body>

<script>
    "use strict";

    function onPageLoading() {
        // Get the user ID from the query string
        var urlString = window.location.href;
        var url = new URL(urlString);
        var id = url.searchParams.get("id");

        callAPIGetDataUserById(id);
    }

    function updateUser() {
        var userId = getUrlParameter("id");
        var firstname = $('#input-firstname').val();
        var lastname = $('#input-lastname').val();
        var subject = $('#input-subject').val();
        var country = $('#select-country').val();
        var customerType = $('#select-customertype').val();
        var registerStatus = $('#select-register-status').val();

        // Validate input data
        if (!firstname || !lastname || !subject || !country || !customerType || !registerStatus) {
            alert('Vui lòng nhập đầy đủ thông tin!');
            return;
        }

        var updatedUser = {
            firstname: firstname,
            lastname: lastname,
            subject: subject,
            country: country,
            customerType: customerType,
            registerStatus: registerStatus
        };

        // Call API to update user
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/" + userId,
            type: "PUT",
            contentType: "application/json",
            data: JSON.stringify(updatedUser),
            success: function (response) {
                // Handle successful response
                alert("Cập nhật thông tin thành công!");
                window.location.href = "listUser.html"; // Replace with the actual URL of the user list page
            },
            error: function (ajaxContext) {
                // Handle error response
                alert("Cập nhật thông tin không thành công: " + ajaxContext.responseText);
            },
        });
    }

    function callAPIGetDataUserById(userId) {
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/" + userId,
            type: "GET",
            dataType: "json",
            success: function (data) {
                showDataUserToForm(data);
            },
            error: function (ajaxContext) {
                alert(ajaxContext.responseText);
            },
        });
    }

    function showDataUserToForm(userData) {
        $("#input-firstname").val(userData.firstname);
        $("#input-lastname").val(userData.lastname);
        $("#select-country").val(userData.country);
        $("#input-subject").val(userData.subject);
        $("#select-customertype").val(userData.customerType);
        $("#select-register-status").val(userData.registerStatus);
    }

    // Helper function to get the value of a URL parameter
    function getUrlParameter(parameter) {
        var urlString = window.location.href;
        var url = new URL(urlString);
        return url.searchParams.get(parameter);
    }
</script>

</html>
